
//                           Ŀ
//                            2D-Portal Engine 
//                           
//                       code: ReDox/MovSD * (C) 1998
//                                version 0.5

#include <stdio.h>
#include <go32.h>
#include <dpmi.h>
#include <sys/nearptr.h>
#define MZX 12
#define MZY 8
#define MAX 100
#define MC 15
#define BS 25
#define XRES 320
#define MBX 7
#define MBY 7
#define MMX 3
#define MMY 3

int left_pressed, right_pressed, center_pressed, dx, dy, mouse_x, mouse_y,
    o_mouse_x, o_mouse_y, x,y, near_vertex, now_selected, last_line=0,
    last_selected_vertex=0, r_line_drawing=0, b_line_drawing=0,
    last_vertex=0;

unsigned char bk_mouse_buffer[MBX*MBY];
unsigned char mouse_buffer[MBX*MBY]={00,00,00,MC,00,00,00,
                                     00,00,00,MC,00,00,00,
                                     00,00,00,MC,00,00,00,
                                     MC,MC,MC,00,MC,MC,MC,
                                     00,00,00,MC,00,00,00,
                                     00,00,00,MC,00,00,00,
                                     00,00,00,MC,00,00,00};

static unsigned char *videoram;

typedef struct { float x; float y; } tpoint;

typedef struct { tpoint v1;
                 tpoint v2; } tlinedef;

typedef struct { void *portal[4];
                 int linedef[4],index; } tsector;

typedef struct { int v1; int v2; } tline;

typedef struct { int v1_visible;
                 int v2_visible;
                 int v1_clip_visible;
                 int v2_clip_visible;
                 tpoint v1_clip;
                 tpoint v2_clip; } tportal_info;

tpoint eye,pv1,pv2,p1,p2,pp,p[MAX/2];
int selected[MAX];
tline lines[MAX];
tsector sector[MZY][MZX];
tlinedef portal[MZX*MZY*4];

int ray_intersection( tpoint *eye, tpoint *dir,
                      tpoint *v1, tpoint *v2,
                      tpoint *p, int interval )
{

// [eye.x;eye.y]-[dir.x;dir.y] -> paprsek
// [v1.x;v1.y]-[v2.x;v2.y] -> linedefa

float s,t,d,

 x1 = eye->x,
 y1 = eye->y,
 x2 = dir->x,
 y2 = dir->y,

 x3 = v1->x,
 y3 = v1->y,
 x4 = v2->x,
 y4 = v2->y;

d=((x1-x2)*(y3-y4)+(x4-x3)*(y1-y2));
if (d==0) return 0;
s=(x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2))/d;
d=(x1-x2);
if (d!=0) {
   t=(x3-x1+s*(x3-x4))/d;
   p->x=x1+t*(x1-x2);
   p->y=y1+t*(y1-y2);
   } else {
   t=1;
   if (y2-y1>0 && y2<y3) t=-1;
   if (y2-y1<0 && y3<y2) t=-1;
   p->x=x1;
   p->y=y3;
   }

return(interval ? (s<=0 && s>=-1 && t<=0) : (s<0 && s>-1 && t<0));

}

void line(tpoint *p1,tpoint *p2, unsigned char c1)
{
  int   dx, dy;
  int ax, ay;
  int sy;
  int x, y;
  int x1=p1->x,y1=p1->y,x2=p2->x,y2=p2->y;
  register char *point,*endpoint;
  register char c=c1;
  if(x1>x2) {
   x1^=x2^=x1^=x2;
   y1^=y2^=y1^=y2;
  }
  dx = x2 - x1;
  dy = y2 - y1;
  ax = dx << 1;
  ay = abs (dy) << 1;
  sy = (dy >= 0) ? 1 : -1;
  x = x1;
  y = y1;

  point = videoram + x + y * XRES;
  endpoint = videoram+x2+y2*XRES;
  if (ax > ay)
    {
      register int             d = ay - (ax >> 1);
      register int aa=ay;
        if(sy>0) {
        while (point!=endpoint)
          {
            *point = c;
            if (d >= 0)
              {
                point += XRES;
                d -= ax;
              }
            point ++;
            d += aa;
          }
        } else {
        while (point!=endpoint)
          {
            *point = c;
            if (d >= 0)
              {
                point -= XRES;
                d -= ax;
              }
            point ++;
            d += aa;
          }
        }
    }
  else
    {
      register int             d = ax - (ay >> 1);
      register int aa=ax;
        if(sy>0) {
        while (point!=endpoint)
          {
            *(point) = c;
            if (d > 0)
              {
                point ++;
                d -= ay;
              }
            point += XRES;
            d += aa;
          }
         } else {
        while (point!=endpoint)
          {
            *(point) = c;
            if (d > 0)
              {
                point ++;
                d -= ay;
              }
            point -= XRES;
            d += aa;
          }
         }
    }
    *(point) = c;
}

static inline void vmode(char c)
{
  __dpmi_regs r;

  r.h.ah        = 0x00;
  r.h.al        = c;
  __dpmi_int (0x10, &r);
}


static inline void set_mouse_position(int x, int y)
{
  __dpmi_regs r;

  r.x.ax = 4;
  r.x.cx = x*8;
  r.x.dx = y*8;
  __dpmi_int (0x33, &r);

}


static inline void set_mouse_speed(int h, int v)
{
  __dpmi_regs r;

  r.x.ax = 15;
  r.x.cx = h;
  r.x.dx = v;
  __dpmi_int (0x33, &r);

}

static inline void hide_mouse()
{
 int x,y;

 for (y=0;y<MBY;y++) for (x=0;x<MBX;x++)
 *(videoram+(o_mouse_y+y-MMY)*XRES+o_mouse_x+x-MMX)=bk_mouse_buffer[y*MBX+x];
}

static inline void show_mouse()
{

 int x,y;

 for (y=0;y<MBY;y++) for (x=0;x<MBX;x++) {
 bk_mouse_buffer[y*MBX+x]=*(videoram+(mouse_y+y-MMY)*XRES+mouse_x+x-MMX);
 if (mouse_buffer[y*MBX+x]!=0)
 *(videoram+(mouse_y+y-MMY)*XRES+mouse_x+x-MMX)=mouse_buffer[y*MBX+x];
 }

}


static inline void show_vertex(int _x, int _y, unsigned char _c)
{

 int x,y;

 for (y=0;y<MBY;y++) for (x=0;x<MBX;x++)
 if (mouse_buffer[y*MBX+x]==MC)
    *(videoram+(_y+y-MMY)*XRES+_x+x-MMX)=_c;

}

static inline void read_mouse()
{
  __dpmi_regs r;

  r.x.ax = 3;
  __dpmi_int (0x33, &r);

  left_pressed = (r.x.bx & 1)==1;
  right_pressed = (r.x.bx & 2)==2;
  center_pressed = (r.x.bx & 4)==4;
  mouse_x = r.x.cx / 8;
  mouse_y = r.x.dx / 8;

}

static inline void set_mouse_range(int x1, int y1, int x2, int y2)
{
  __dpmi_regs r;

  r.x.ax = 7;
  r.x.cx = x1*8;
  r.x.dx = x2*8;
  __dpmi_int (0x33, &r);

  r.x.ax = 8;
  r.x.cx = y1*8;
  r.x.dx = y2*8;
  __dpmi_int (0x33, &r);

}

void visibility(tsector *s, tpoint *e, tpoint *p1, tpoint *p2, int exclude)
{
 int last_linedef=4,x,i;
 tpoint pp,l1,l2;
 tportal_info info[4];

 for (x=0;x<last_linedef;x++) {
     info[x].v1_clip_visible=0;
     info[x].v2_clip_visible=0;
     info[x].v1_visible=0;
     info[x].v2_visible=0;
     }

 for (x=0;x<last_linedef;x++) {

     i=s->linedef[x];

     if (i!=exclude && ray_intersection(e,&portal[i].v1,p1,p2,&pp,1)) {
        info[x].v1_visible=1;
        //line(e,&portal[i].v1,11);
        }

     if (i!=exclude && ray_intersection(e,&portal[i].v2,p1,p2,&pp,1)) {
        info[x].v2_visible=1;
        //line(e,&portal[i].v2,11);
        }
     }

 for (x=0;x<last_linedef;x++) {
     i=s->linedef[x];
     if (i!=exclude && ray_intersection(e,p1,
        &portal[i].v1,
        &portal[i].v2,
        &info[x].v1_clip,0)) {
        info[x].v1_clip_visible=1;
        //line(e,&info[x].v1_clip,11);
        break;
        }
     }

 for (x=0;x<last_linedef;x++) {
     i=s->linedef[x];
     if (i!=exclude && ray_intersection(e,p2,
        &portal[i].v1,
        &portal[i].v2,
        &info[x].v2_clip,0)) {
        info[x].v2_clip_visible=1;
        //line(e,&info[x].v2_clip,11);
        break;
        }
     }

 for (x=0;x<last_linedef;x++) do {

     i=s->linedef[x];
     if (i==exclude) break;

     if (info[x].v1_visible && info[x].v2_visible) {
        if (s->portal[x])
           visibility(s->portal[x],e,&portal[i].v1,&portal[i].v2,i);
           else line(&portal[i].v1,&portal[i].v2,2);
        break;
        }

     if (info[x].v1_clip_visible && info[x].v2_visible) {
        if (s->portal[x])
           visibility(s->portal[x],e,&info[x].v1_clip,&portal[i].v2,i);
           else line(&info[x].v1_clip,&portal[i].v2,2);
        break;
        }

     if (info[x].v1_visible && info[x].v2_clip_visible) {
        if (s->portal[x])
           visibility(s->portal[x],e,&portal[i].v1,&info[x].v2_clip,i);
           else line(&portal[i].v1,&info[x].v2_clip,2);
        break;
        }

     if (info[x].v1_clip_visible && info[x].v1_visible) {
        if (s->portal[x])
           visibility(s->portal[x],e,&info[x].v1_clip,&portal[i].v1,i);
           else line(&info[x].v1_clip,&portal[i].v1,2);
        break;
        }

     if (info[x].v2_visible && info[x].v2_clip_visible) {
        if (s->portal[x])
           visibility(s->portal[x],e,&portal[i].v2,&info[x].v2_clip,i);
           else line(&portal[i].v2,&info[x].v2_clip,2);
        break;
        }

     if (info[x].v1_clip_visible && info[x].v2_clip_visible) {
        if (s->portal[x])
           visibility(s->portal[x],e,&info[x].v1_clip,&info[x].v2_clip,i);
           else line(&info[x].v1_clip,&info[x].v2_clip,2);
        break;
        }

     } while(0);
 }

int main()
{

 char s[80];
 int i,j;
 FILE *f;

 __djgpp_nearptr_enable();
 videoram=(unsigned char *)__djgpp_conventional_base+0xA0000;

 i=1;

 f=fopen("maze.txt","r");
 for (y=0;y<MZY;y++) {
     fgets(s,sizeof(s),f);
     for (x=0;x<MZX;x++) sector[y][x].index = (s[x]=='#') ? 0 : i++;
     }
 fclose(f);

 vmode(0x13);

 for (y=0,i=0;y<MZY+1;y++)
     for (x=0;x<MZX+1;x++) {
         portal[i].v1.x=x*BS;
         portal[i].v1.y=y*BS;
         portal[i].v2.x=(x+1)*BS;
         portal[i].v2.y=y*BS;
         i++;
         }
 j=i;

 for (y=0;y<MZY+1;y++)
     for (x=0;x<MZX+1;x++) {
         portal[i].v1.x=x*BS;
         portal[i].v1.y=y*BS;
         portal[i].v2.x=x*BS;
         portal[i].v2.y=(y+1)*BS;
         i++;
         }

 for (y=0;y<MZY;y++) for (x=0;x<MZX;x++)
     if (sector[y][x].index) {
         sector[y][x].linedef[0]=x+y*(MZX+1);
         line(&portal[x+y*(MZX+1)].v1,&portal[x+y*(MZX+1)].v2,0);
         sector[y][x].linedef[1]=j+x+y*(MZX+1)+1;
         line(&portal[j+x+y*(MZX+1)+1].v1,&portal[j+x+y*(MZX+1)+1].v2,0);
         sector[y][x].linedef[2]=x+(y+1)*(MZX+1);
         line(&portal[x+(y+1)*(MZX+1)].v1,&portal[x+(y+1)*(MZX+1)].v2,0);
         sector[y][x].linedef[3]=j+x+y*(MZX+1);
         line(&portal[j+x+y*(MZX+1)].v1,&portal[j+x+y*(MZX+1)].v2,0);
         sector[y][x].portal[0]=(y>0 && sector[y-1][x].index) ? &sector[y-1][x] : NULL;
         sector[y][x].portal[1]=(x<MZX-1 && sector[y][x+1].index) ? &sector[y][x+1] : NULL;
         sector[y][x].portal[2]=(y<MZY-1 && sector[y+1][x].index) ? &sector[y+1][x] : NULL;
         sector[y][x].portal[3]=(x>0 && sector[y][x-1].index) ? &sector[y][x-1] : NULL;
         }

 for (x=0;x<MAX;x++) selected[x]=-1;
 for (y=0;y<MZY;y++) for (x=0;x<MZX;x++)
     if (sector[y][x].index)
        for (i=0;i<4;i++) {
            j=sector[y][x].linedef[i];
            if (sector[y][x].portal[i])
               line(&portal[j].v1,&portal[j].v2,8);
               else line(&portal[j].v1,&portal[j].v2,7);
            }

 set_mouse_range(3,3,316,196);
 set_mouse_position(160,100);
 set_mouse_speed(4,4);
 show_mouse();

 while(!right_pressed)
 {

 read_mouse();

 if (mouse_x!=o_mouse_x || mouse_y!=o_mouse_y)
    {
    hide_mouse();
    show_mouse();
    o_mouse_x=mouse_x;
    o_mouse_y=mouse_y;
    }

 if (kbhit())
 switch (getch()) {
 case ' ':center_pressed=1;
          break;
 case 'e':eye.x=mouse_x;
          eye.y=mouse_y;
          hide_mouse();
          show_vertex(eye.x,eye.y,1);
          show_mouse();
          break;
 case '1':pv1.x=mouse_x;
          pv1.y=mouse_y;
          break;
 case '2':pv2.x=mouse_x;
          pv2.y=mouse_y;
          hide_mouse();
          line(&pv1,&pv2,1);
          show_mouse();
          break;
 case '`':hide_mouse();
          visibility(&sector[(int)pv1.y/BS][(int)pv1.x/BS],&eye,&pv1,&pv2,0xffff);
          show_mouse();
          break;
 }


 if (left_pressed) {
    delay(200);
    hide_mouse();
    if (last_selected_vertex>0) {
       for (x=0;x<last_selected_vertex-1;x++) {
           lines[last_line].v1=selected[x];
           lines[last_line++].v2=selected[x+1];
           line(&p[selected[x]],&p[selected[x+1]],4);
           show_vertex(p[selected[x]].x,p[selected[x]].y,2);
           show_vertex(p[selected[x+1]].x,p[selected[x+1]].y,2);
           }
       last_selected_vertex=0;
       for (x=0;x<MAX;x++) selected[x]=-1;
       } else {
       show_vertex(mouse_x,mouse_y,2);
       p[last_vertex].x=mouse_x;
       p[last_vertex++].y=mouse_y;
       }
    show_mouse();
    }

 if (center_pressed) {

    delay(200);
    dx=320;
    dy=200;
    now_selected=1;

    for (x=0;x<=last_vertex;x++)
        if (abs(p[x].y-mouse_y)+abs(p[x].x-mouse_x)<dx+dy) {
           near_vertex=x;
           dx=abs(p[x].x-mouse_x);
           dy=abs(p[x].y-mouse_y);
           }

    for (x=0;x<=last_selected_vertex;x++)
        if (near_vertex==selected[x]) {
           show_vertex(p[near_vertex].x,p[near_vertex].y,2);
           for (y=x;y<last_selected_vertex;y++)
               selected[y]=selected[y+1];
           last_selected_vertex--;
           now_selected=0;
           break;
           }

    if (now_selected) {

    selected[last_selected_vertex++]=near_vertex;

    hide_mouse();
    show_vertex(p[near_vertex].x,p[near_vertex].y,4);
    show_mouse();

    }

  }

 }

 hide_mouse();

 vmode(3);

 printf("\n 2D - Portal Engine  - code: ReDox/MovSD (C) 1998\n");

 return 0;

}
